@echo off
setlocal EnableDelayedExpansion
for /f "delims=" %%X in ('echo %0') do (
set cmddrive=%%~dX
@ECHO CMD File Drive: !cmddrive!
set cmdpath=%%~pX
@ECHO CMD File Path: !cmdpath!
set cmdfilename=%%~nX
@ECHO CMD File Name: !cmdfilename!
set cmdfileext=%%~xX
@ECHO CMD File Ext: !cmdfileext!
@ECHO --- ---
rem for /f "delims=" %%X in ('echo %0') do (
)
rem default current program
if %cd% equ %systemroot%\system32 echo Running as admin
set currentboinctempcontrolprogramfulldirnquotes=%0
set currentboinctempcontrolprogramname=!cmdfilename!!cmdfileext!
if %cd% equ %systemroot%\system32 call set currentboinctempcontroldirectoryprogram=%%currentboinctempcontrolprogramfulldirnquotes:\%currentboinctempcontrolprogramname%=%%
if %cd% equ %systemroot%\system32 echo Current directory is: %cd%
if %cd% equ %systemroot%\system32 echo Changing directory to: %currentboinctempcontroldirectoryprogram%
if %cd% equ %systemroot%\system32 echo.
if %cd% equ %systemroot%\system32 cd %currentboinctempcontroldirectoryprogram%
if %cd% NEQ %systemroot%\system32 set currentboinctempcontroldirectory=%cd%
call set currentboinctempcontrolprogramnopath=%%currentboinctempcontrolprogramfulldirnquotes:%currentboinctempcontroldirectory%\=%%
set currentboinctempcontrolprogramfull=%currentboinctempcontrolprogramnopath:"=%
set currentboinctempcontrolprogram=%currentboinctempcontrolprogramfull:.cmd=%
set currentboinctempcontrolprogramcmd=%currentboinctempcontrolprogram%.cmd
echo (..  ..  ..  ..  ..  ..  ..  ..)
echo (  ..  ..  ..  ..  ..  ..  ..  )
echo %date% %time%
echo Running program %currentboinctempcontrolprogramcmd%
echo Located in directory: %currentboinctempcontroldirectory%
set pgmver=0.3
echo Ver. %pgmver%
:: Get windows Version numbers
For /F "tokens=2 delims=[]" %%G in ('ver') Do (set _version=%%G)
For /F "tokens=2,3,4 delims=. " %%G in ('echo %_version%') Do (set _major=%%G& set _minor=%%H& set _build=%%I)
Echo Major version: %_major%  Minor Version: %_minor%.%_build%
if "%_major%"=="5" goto :sub5
if "%_major%"=="6" goto :sub6

Echo Unsupported Version
goto :dontrun

:sub5
::Winxp or 2003
if "%_minor%"=="2" goto :sub_2003
Echo Windows XP [%PROCESSOR_ARCHITECTURE%]
goto :versioncontinue

:sub_2003
Echo Windows 2003 or XP 64 bit [%PROCESSOR_ARCHITECTURE%]
goto :versioncontinue

:sub6
if "%_minor%"=="1" goto :sub7
if "%_minor%"=="2" goto :sub8
if "%_minor%"=="3" goto :sub81
Echo Windows Vista or Windows 2008 [%PROCESSOR_ARCHITECTURE%]
goto :versioncontinue

:sub7
Echo Windows 7 or Windows 2008 R2 [%PROCESSOR_ARCHITECTURE%]
goto :versioncontinue

:sub8
Echo Windows 8 [%PROCESSOR_ARCHITECTURE%]

:sub81
Echo Windows 8.1 [%PROCESSOR_ARCHITECTURE%]
:versioncontinue
echo (..  ..  ..  ..  ..  ..  ..  ..)
echo (  ..  ..  ..  ..  ..  ..  ..  )
rem output format filler
set boinctempcontroloutputfiller=`````````````````````````````````````````````````````````````````````````````````````
rem ---
rem put value here
set boinctempcontrolputvaluehere=70
rem ---
rem process client state file once
set boinctempcontrolclientprocessed=no
rem ---
rem  default wget temperature
set defboincwgettemperature=1000
set boinctempcontroltemperature=1000
rem ---
rem ----------------
echo Registry value^(s^) Start
set boinctempcontrolregistryissue=no
rem registry value wget install directory
(set wgetexedir=)
set wow6432value=\Wow6432Node
if x%PROCESSOR_ARCHITECTURE% EQU xx86 (set wow6432value=)
set key_name=HKEY_LOCAL_MACHINE\SOFTWARE%wow6432value%\GnuWin32\Wget
set value_name=InstallPath
call :getregistryvalue wgetinstalldir
if defined wgetinstalldir (set boinctempcontroloutputpart1=Wget %value_name% Registry )
if defined wgetinstalldir (set boinctempcontroloutputpart2=value: %wgetinstalldir% )
if defined wgetinstalldir call :eocuhtotheline
if NOT defined wgetinstalldir (
echo.
echo Error WGet Registry entry is missing or invalid directory is stored in registry
echo.
echo You can download wget program here
echo "http://gnuwin32.sourceforge.net/packages/wget.htm"
echo.
echo -------------------
set boinctempcontrolregistryissue=yes
rem if NOT defined wgetinstalldir (
)
rem ---
rem registry value boinc install directory
(set boincinstalldir=)
set key_name=HKEY_LOCAL_MACHINE\SOFTWARE\Space Sciences Laboratory, U.C. Berkeley\BOINC Setup
set value_name=INSTALLDIR
call :getregistryvalue boincinstalldir
if defined boincinstalldir (set boinctempcontroloutputpart1=Boinc %value_name% Registry )
if defined boincinstalldir (set boinctempcontroloutputpart2=value: %boincinstalldir% )
if defined boincinstalldir call :eocuhtotheline
if NOT defined boincinstalldir (
echo.
echo Error Boinc Registry entry is missing or invalid directory is stored in registry
echo.
echo You can download Boinc program here
echo "http://boinc.berkeley.edu/"
echo.
echo -------------------
set boinctempcontrolregistryissue=yes
rem if NOT defined boincinstalldir (
)
rem registry value boinc data directory
(set boincdatadir=)
set key_name=HKEY_LOCAL_MACHINE\SOFTWARE\Space Sciences Laboratory, U.C. Berkeley\BOINC Setup
set value_name=DATADIR
call :getregistryvalue boincdatadir
if defined boincdatadir (set boinctempcontroloutputpart1=Boinc %value_name% Registry )
if defined boincdatadir (set boinctempcontroloutputpart2=value: %boincdatadir% )
if defined boincdatadir call :eocuhtotheline
if NOT defined boincdatadir (
echo.
echo Error Boinc Registry entry is missing or invalid directory is stored in registry
echo.
echo You can download Boinc program here
echo "http://boinc.berkeley.edu/"
echo.
echo -------------------
set boinctempcontrolregistryissue=yes
rem if NOT defined boincinstalldir (
)
rem ---
echo Registry value^(s^) Complete
if x%boinctempcontrolregistryissue% EQU xyes (
echo -------------------
echo.
echo Registry Error^(s^) detected.
echo.
echo Exiting ... Now
goto :dontrun
rem if x%boinctempcontrolregistryissue% EQU xyes (
)
rem change to path locate wget.exe
call :strlen wgetinstalldirlength %wgetinstalldir%
set /A wgetinstalldirlengthcharstrt=wgetinstalldirlength
call set wgetinstalldirlengthchar=%%wgetinstalldir:~%wgetinstalldirlengthcharstrt%,1%%
if x%wgetinstalldirlengthchar% NEQ x\ set wgetinstalldir="%wgetinstalldir:"=%\"
set wgetinstalldir=%wgetinstalldir:"=%
set defboinctempcontrolwgetinstalldirectory="%wgetinstalldir%"
rem ---
rem change path to locate Boinc boinccmd.exe
call :strlen boincinstalldirlength %boincinstalldir%
set /A boincinstalldirlengthcharstrt=boincinstalldirlength
call set boincinstalldirlengthchar=%%boincinstalldir:~%boincinstalldirlengthcharstrt%,1%%
if x%boincinstalldirlengthchar% NEQ x\ set boincinstalldir="%boincinstalldir:"=%\"
set boincinstalldir=%boincinstalldir:"=%
set defboinctempcontrolboinccmddirectoryprogram="%boincinstalldir%boinccmd.exe"
set boincinstalldir="%boincinstalldir%"
rem ---
rem change path to locate Boinc client_state.xml
call :strlen boincdatadirlength %boincdatadir%
set /A boincdatadirlengthcharstrt=boincdatadirlength
call set boincdatadirlengthchar=%%boincdatadir:~%boincdatadirlengthcharstrt%,1%%
if "x%boincdatadirlengthchar%" NEQ "x\" set boincdatadir="%boincdatadir:"=%\"
set boincdatadir=%boincdatadir:"=%
set defboinctempcontrolboincdatadirectory="%boincdatadir%"
set boincdatadir="%boincdatadir%"
rem ---
rem
rem default control ini
set defboinctempcontrolcontrolinidirectoryfilename=".\%currentboinctempcontrolprogram%-control.ini"
rem ---
rem delay program choose or choice
set defboinctempcontroldelayprogram=choice
(set boinctempcontroldelayprogram=)
rem ---
rem win32 choose directory
set defboinctempcontrolchoosedirectoryprogram=".\editv22\choose32.exe"
(set boinctempcontrolchoosedirectoryprogram=)
rem ---
rem win32 choice directory and program
set defboinctempcontrolchoicedirectoryprogram="%windir%\system32\choice.exe"
(set boinctempcontrolchoicedirectoryprogram=)
rem ---
rem Run Only once.
set defboinctempcontrolrunonlyonce=yes
(set boinctempcontrolrunonlyonce=)
rem ---
rem delay in seconds for run again
set defboinctempcontrolrunagaindelay=600
(set boinctempcontrolrunagaindelay=)
rem ---
rem Boinc resume option values always auto never
set defboinctempcontrolboincresumeoption=auto
(set boinctempcontrolboincresumeoption=)
rem ---
rem final directory and program for wget program
set defboinctempcontrolwgetfinaldirectoryprogram="bin\wget.exe"
(set boinctempcontrolwgetfinaldirectoryprogram=)
rem ---
rem set path to locate wget.exe
set  boinctempcontrolwgetinstalldirectory=%defboinctempcontrolwgetinstalldirectory:"=%
set  boinctempcontrolwgetfinaldirectoryprogram=%defboinctempcontrolwgetfinaldirectoryprogram:"=%
set boinctempcontrolwgetdirectoryprogram="%boinctempcontrolwgetinstalldirectory%%boinctempcontrolwgetfinaldirectoryprogram%"
(set  boinctempcontrolwgetinstalldirectory=)
(set  boinctempcontrolwgetfinaldirectoryprogram=)
rem ---
rem wget optons
set defboinctempcontrolwgetoptions="-nv"
(set boinctempcontrolwgetoptions=)
rem ---
rem weather location
set defboinctempcontrolweatherloc="London,UK"
(set boinctempcontrolweatherloc=)
rem ---
rem weather units metric or imperial 
set defboinctempcontrolweatherunits=metric
(set boinctempcontrolweatherunits=)
rem ---
rem weather info url
set boinctempcontrolweatherlocd=%defboinctempcontrolweatherloc:"=%
set defboinctempcontrolweatherurl="http://api.openweathermap.org/data/2.5/weather?q=%boinctempcontrolweatherlocd%&mode=xml&units=%defboinctempcontrolweatherunits%"
(set boinctempcontrolweatherurl=)
rem ---
rem weather results file
set defboinctempcontrolweatherinfofile=".\%currentboinctempcontrolprogram%-weather.txt"
(set boinctempcontrolweatherinfofile=)
rem ---
rem temperature to suspend processing
set defboinctempcontroltemptosuspend="24.00"
rem make appropiate adjustments for metric or imperial
(set boinctempcontroltemptosuspend=)
rem ---
rem count match of temperature to suspend processing
set defboinctempcontrolmatchoftemptosuspend=2
(set boinctempcontrolmatchoftemptosuspend=)
set boinctempcontrolmatchoftemptosuspendrun=0
rem ---
rem temperature to resme processing
set defboinctempcontroltemptoresume="23.00"
rem make appropiate adjustments for metric or imperial
(set boinctempcontroltemptoresume=)
rem ---
rem count match of temperature to resme processing
set defboinctempcontrolmatchoftemptoresume=2
(set boinctempcontrolmatchoftemptoresume=)
set boinctempcontrolmatchoftemptoresumerun=0
rem ---
rem temperature suspend default
set defboinctempcontroltempsuspended=no
(set boinctempcontroltempsuspended=)
rem ---
rem log boinc processing changes due to tempurature default
set defboinctempcontrollogtempevents=yes
(set boinctempcontrollogtempevents=)
rem ---
rem temperature suspend log file
set defboinctempcontrollogfile=".\%currentboinctempcontrolprogram%-log.txt"
(set boinctempcontrollogfile=)
rem ---
rem Run Only once.
set defboinctempcontrolrunonlyonce=yes
(set boinctempcontrolrunonlyonce=)
rem ---
rem default run with
set defboinctempcontrolrunwith=call
rem ---
rem default stop run
set defboinctempcontrolstoprun=no
(set boinctempcontrolstoprun=)
rem ---
rem delay in seconds for output review
set defboinctempcontroloutputreviewdelay=60
rem ---
rem output debug message level 1-4
set defboinctempcontroloutputmessagelevel=1
(set boinctempcontroloutputmessagelevel=)
rem ---
rem log output line
set logoutputline=ooooo
rem ---
rem Debug
rem show subs entered
set defboinctempcontrolsubroutinemsg=no
(set boinctempcontrolsubroutinemsg=)
rem ---
rem process wget commands
set defboinctempcontrolrunwgetcmd=yes
(set boinctempcontrolrunwgetcmd=)
rem ---
rem process boincmd commands
set defboinctempcontrolrunboinccmd=yes
(set boinctempcontrolrunboinccmd=)
rem ---
rem Test flag
set defboinctempcontroltestrun=no
set boinctempcontrolruncomdtext=echo Run this command:
set boinctempcontrolrunflag=yes
rem ---
echo -------------------
echo Processing Arg Input Start
rem info request
if [%1]==[/?] goto :reqinfo
if [%2]==[/?] goto :reqinfo
if [%3]==[/?] goto :reqinfo
if [%4]==[/?] goto :reqinfo
if [%5]==[/?] goto :reqinfo
if [%6]==[/?] goto :reqinfo
if [%7]==[/?] goto :reqinfo
if [%8]==[/?] goto :reqinfo

rem passed args
if not [%1]==[] set boinctempcontrolparseargprm1=%1
if not [%2]==[] set boinctempcontrolparseargprm2=%2
if not [%3]==[] set boinctempcontrolparseargprm3=%3
if not [%4]==[] set boinctempcontrolparseargprm4=%4
if not [%5]==[] set boinctempcontrolparseargprm5=%5
if not [%6]==[] set boinctempcontrolparseargprm6=%6
if not [%7]==[] set boinctempcontrolparseargprm7=%7
if not [%8]==[] set boinctempcontrolparseargprm8=%8
rem ----------------

rem ini directory and filename

call :processarginput /inidirectoryfilename: %defboinctempcontrolcontrolinidirectoryfilename% boinctempcontrolcontrolinidirectoryfilename notoktosetvaluetoparms boinctempcontrolcontrolprgmparms1

rem ----------------
rem Run with start or call

call :processarginput /runwith: %defboinctempcontrolrunwith% boinctempcontrolrunwith notoktosetvaluetoparms boinctempcontrolprgmparms2

rem ----------------
rem test run

call :processarginput /testrun: %defboinctempcontroltestrun% boinctempcontroltestrun notoktosetvaluetoparms boinctempcontrolprgmparms3

rem ----------------

if %boinctempcontroltestrun% equ yes echo Running Test
if %boinctempcontroltestrun% neq yes (set boinctempcontrolruncomdtext=)
if %boinctempcontroltestrun% neq yes (set boinctempcontrolrunflag=)
echo Processing Arg Input Complete

:runtemperaturecheckagain

rem process according to control file
echo -------------------
echo Processing Control ini file Start
set boinctempcontrolechooutputtype=control
set boinctempcontrolcontrolinitemp=.\%currentboinctempcontrolprogram%-control-temp.ini
if not exist %boinctempcontrolcontrolinidirectoryfilename% goto :noinifile
if exist %boinctempcontrolcontrolinidirectoryfilename% type "%boinctempcontrolcontrolinidirectoryfilename%" >"%boinctempcontrolcontrolinitemp%"
goto :gotinifile

:noinifile
echo The INI file specified in above variable inidirectoryfilename missing value: %boinctempcontrolcontrolinidirectoryfilename%
goto :skipprocessitini

:gotinifile
FOR /F "tokens=1,2 delims=;" %%A IN ('type "%boinctempcontrolcontrolinitemp%"') DO (
call :processcontrolini %%A %%B
)

:skipprocessitini
if exist %boinctempcontrolcontrolinitemp% (del %boinctempcontrolcontrolinitemp%)

rem set default stop run value
if not defined boinctempcontrolstoprun (set boinctempcontroloutputpart1=No value read from ini using default stoprun)
if not defined boinctempcontrolstoprun (set boinctempcontroloutputpart2=value: %defboinctempcontrolstoprun%)
if not defined boinctempcontrolstoprun call :eocuhtotheline
if not defined boinctempcontrolstoprun (set boinctempcontrolstoprun=%defboinctempcontrolstoprun%)

rem set default change the path to locate wget.exe value
if not defined boinctempcontrolwgetinstalldirectory (set boinctempcontroloutputpart1=No value read from ini using default wgetinstalldirectory)
if not defined boinctempcontrolwgetinstalldirectory (set boinctempcontroloutputpart2=value: %defboinctempcontrolwgetinstalldirectory%)
if not defined boinctempcontrolwgetinstalldirectory call :eocuhtotheline
if not defined boinctempcontrolwgetinstalldirectory (set boinctempcontrolwgetinstalldirectory=%defboinctempcontrolwgetinstalldirectory%)

rem set default change the path to locate boinccmd.exe value
if not defined boinctempcontrolboinccmddirectoryprogram (set boinctempcontroloutputpart1=No value read from ini using default boinccmddirectoryprogram)
if not defined boinctempcontrolboinccmddirectoryprogram (set boinctempcontroloutputpart2=value: %defboinctempcontrolboinccmddirectoryprogram%)
if not defined boinctempcontrolboinccmddirectoryprogram call :eocuhtotheline
if not defined boinctempcontrolboinccmddirectoryprogram (set boinctempcontrolboinccmddirectoryprogram=%defboinctempcontrolboinccmddirectoryprogram%)

rem set default change the path to locate client_state.xml value
if not defined boinctempcontrolboincdatadirectory (set boinctempcontroloutputpart1=No value read from ini using default boincdatadirectory)
if not defined boinctempcontrolboincdatadirectory (set boinctempcontroloutputpart2=value: %defboinctempcontrolboincdatadirectory%)
if not defined boinctempcontrolboincdatadirectory call :eocuhtotheline
if not defined boinctempcontrolboincdatadirectory (set boinctempcontrolboincdatadirectory=%defboinctempcontrolboincdatadirectory%)

rem set default delay program value
if not defined boinctempcontroldelayprogram (set boinctempcontroloutputpart1=No value read from ini using default delayprogram)
if not defined boinctempcontroldelayprogram (set boinctempcontroloutputpart2=value: %defboinctempcontroldelayprogram%)
if not defined boinctempcontroldelayprogram call :eocuhtotheline
if not defined boinctempcontroldelayprogram (set boinctempcontroldelayprogram=%defboinctempcontroldelayprogram%)

rem set default choose directory value
if not defined boinctempcontrolchoosedirectoryprogram (set boinctempcontroloutputpart1=No value read from ini using default choosedirectoryprogram)
if not defined boinctempcontrolchoosedirectoryprogram (set boinctempcontroloutputpart2=value: %defboinctempcontrolchoosedirectoryprogram%)
if not defined boinctempcontrolchoosedirectoryprogram call :eocuhtotheline
if not defined boinctempcontrolchoosedirectoryprogram (set boinctempcontrolchoosedirectoryprogram=%defboinctempcontrolchoosedirectoryprogram%)

rem set default choice directory value
if not defined boinctempcontrolchoicedirectoryprogram (set boinctempcontroloutputpart1=No value read from ini using default choicedirectoryprogram)
if not defined boinctempcontrolchoicedirectoryprogram (set boinctempcontroloutputpart2=value: %defboinctempcontrolchoicedirectoryprogram%)
if not defined boinctempcontrolchoicedirectoryprogram call :eocuhtotheline
if not defined boinctempcontrolchoicedirectoryprogram (set boinctempcontrolchoicedirectoryprogram=%defboinctempcontrolchoicedirectoryprogram%)

rem set default Run Only once value
if not defined boinctempcontrolrunonlyonce (set boinctempcontroloutputpart1=No value read from ini using default runonlyonce)
if not defined boinctempcontrolrunonlyonce (set boinctempcontroloutputpart2=value: %defboinctempcontrolrunonlyonce%)
if not defined boinctempcontrolrunonlyonce call :eocuhtotheline
if not defined boinctempcontrolrunonlyonce (set boinctempcontrolrunonlyonce=%defboinctempcontrolrunonlyonce%)

rem set default delay in seconds for run again value
if not defined boinctempcontrolrunagaindelay (set boinctempcontroloutputpart1=No value read from ini using default runagaindelay)
if not defined boinctempcontrolrunagaindelay (set boinctempcontroloutputpart2=value: %defboinctempcontrolrunagaindelay%)
if not defined boinctempcontrolrunagaindelay call :eocuhtotheline
if not defined boinctempcontrolrunagaindelay (set boinctempcontrolrunagaindelay=%defboinctempcontrolrunagaindelay%)

rem set default Boinc resume option
if not defined boinctempcontrolboincresumeoption (set boinctempcontroloutputpart1=No value read from ini using default boincresumeoption)
if not defined boinctempcontrolboincresumeoption (set boinctempcontroloutputpart2=value: %defboinctempcontrolboincresumeoption%)
if not defined boinctempcontrolboincresumeoption call :eocuhtotheline
if not defined boinctempcontrolboincresumeoption (set boinctempcontrolboincresumeoption=%defboinctempcontrolboincresumeoption%)
if /I x%boinctempcontrolboincresumeoption% EQU xclient call :processclientstateruserrunrequest boinctempcontrolboincresumeoption

rem set default final directory and program for wget value
if not defined boinctempcontrolwgetfinaldirectoryprogram (set boinctempcontroloutputpart1=No value read from ini using default wgetfinaldirectoryprogram)
if not defined boinctempcontrolwgetfinaldirectoryprogram (set boinctempcontroloutputpart2=value: %defboinctempcontrolwgetfinaldirectoryprogram%)
if not defined boinctempcontrolwgetfinaldirectoryprogram call :eocuhtotheline
if not defined boinctempcontrolwgetfinaldirectoryprogram (set boinctempcontrolwgetfinaldirectoryprogram=%defboinctempcontrolwgetfinaldirectoryprogram%)

rem set default wget options value
if not defined boinctempcontrolwgetoptions (set boinctempcontroloutputpart1=No value read from ini using default wgetoptions)
if not defined boinctempcontrolwgetoptions (set boinctempcontroloutputpart2=value: %defboinctempcontrolwgetoptions%)
if not defined boinctempcontrolwgetoptions call :eocuhtotheline
if not defined boinctempcontrolwgetoptions (set boinctempcontrolwgetoptions=%defboinctempcontrolwgetoptions:"=%)

rem set default weather location value
if not defined boinctempcontrolweatherloc (set boinctempcontroloutputpart1=No value read from ini using default weatherloc)
if not defined boinctempcontrolweatherloc (set boinctempcontroloutputpart2=value: %defboinctempcontrolweatherloc%)
if not defined boinctempcontrolweatherloc call :eocuhtotheline
if not defined boinctempcontrolweatherloc (set boinctempcontrolweatherloc=%defboinctempcontrolweatherloc:"=%)

rem set default weather tempurature format value
if not defined boinctempcontrolweatherunits (set boinctempcontroloutputpart1=No value read from ini using default weatherunits)
if not defined boinctempcontrolweatherunits (set boinctempcontroloutputpart2=value: %defboinctempcontrolweatherunits%)
if not defined boinctempcontrolweatherunits call :eocuhtotheline
if not defined boinctempcontrolweatherunits (set boinctempcontrolweatherunits=%defboinctempcontrolweatherunits%)

rem set default weather info url value
if not defined boinctempcontrolweatherurl (set boinctempcontroloutputpart1=No value read from ini using default weatherurl)
if not defined boinctempcontrolweatherurl (set boinctempcontroloutputpart2=value: "http://api.openweathermap.org/data/2.5/weather?q=!boinctempcontrolweatherloc!&mode=xml&units=!boinctempcontrolweatherunits!")
if not defined boinctempcontrolweatherurl call :eocuhtotheline
if not defined boinctempcontrolweatherurl call set boinctempcontrolweatherurl="http://api.openweathermap.org/data/2.5/weather?q=!boinctempcontrolweatherloc!&mode=xml&units=!boinctempcontrolweatherunits!"

rem set default weather results file value
if not defined boinctempcontrolweatherinfofile (set boinctempcontroloutputpart1=No value read from ini using default weatherinfofile)
if not defined boinctempcontrolweatherinfofile (set boinctempcontroloutputpart2=value: %defboinctempcontrolweatherinfofile%)
if not defined boinctempcontrolweatherinfofile call :eocuhtotheline
if not defined boinctempcontrolweatherinfofile (set boinctempcontrolweatherinfofile=%defboinctempcontrolweatherinfofile%)

rem set default temperature to suspend boinc processing value
if not defined boinctempcontroltemptosuspend (set boinctempcontroloutputpart1=No value read from ini using default temptosuspend)
if not defined boinctempcontroltemptosuspend (set boinctempcontroloutputpart2=value: %defboinctempcontroltemptosuspend%)
if not defined boinctempcontroltemptosuspend call :eocuhtotheline
if not defined boinctempcontroltemptosuspend (set boinctempcontroltemptosuspend=%defboinctempcontroltemptosuspend%)

rem set default count match of temperature to suspend boinc processing value
if not defined boinctempcontrolmatchoftemptosuspend (set boinctempcontroloutputpart1=No value read from ini using default matchoftemptosuspend)
if not defined boinctempcontrolmatchoftemptosuspend (set boinctempcontroloutputpart2=value: %defboinctempcontrolmatchoftemptosuspend%)
if not defined boinctempcontrolmatchoftemptosuspend call :eocuhtotheline
if not defined boinctempcontrolmatchoftemptosuspend (set boinctempcontrolmatchoftemptosuspend=%defboinctempcontrolmatchoftemptosuspend%)

rem set default temperature to resume boinc processing value
if not defined boinctempcontroltemptoresume (set boinctempcontroloutputpart1=No value read from ini using default temptoresume)
if not defined boinctempcontroltemptoresume (set boinctempcontroloutputpart2=value: %defboinctempcontroltemptoresume%)
if not defined boinctempcontroltemptoresume call :eocuhtotheline
if not defined boinctempcontroltemptoresume (set boinctempcontroltemptoresume=%defboinctempcontroltemptoresume%)

rem set default count match of temperature to resume boinc processing value
if not defined boinctempcontrolmatchoftemptoresume (set boinctempcontroloutputpart1=No value read from ini using default matchoftemptoresume)
if not defined boinctempcontrolmatchoftemptoresume (set boinctempcontroloutputpart2=value: %defboinctempcontrolmatchoftemptoresume%)
if not defined boinctempcontrolmatchoftemptoresume call :eocuhtotheline
if not defined boinctempcontrolmatchoftemptoresume (set boinctempcontrolmatchoftemptoresume=%defboinctempcontrolmatchoftemptoresume%)

rem set default boinc tempurature suspended value
if not defined boinctempcontroltempsuspended (set boinctempcontroloutputpart1=No value read from ini using default tempsuspended)
if not defined boinctempcontroltempsuspended (set boinctempcontroloutputpart2=value: %defboinctempcontroltempsuspended%)
if not defined boinctempcontroltempsuspended call :eocuhtotheline
if not defined boinctempcontroltempsuspended (set boinctempcontroltempsuspended=%defboinctempcontroltempsuspended%)

rem set default log boinc processing changes due to tempurature value
if not defined boinctempcontrollogtempevents (set boinctempcontroloutputpart1=No value read from ini using default logtempevents)
if not defined boinctempcontrollogtempevents (set boinctempcontroloutputpart2=value: %defboinctempcontrollogtempevents%)
if not defined boinctempcontrollogtempevents call :eocuhtotheline
if not defined boinctempcontrollogtempevents (set boinctempcontrollogtempevents=%defboinctempcontrollogtempevents%)

rem set default log file for boinc tempurature activities value
if not defined boinctempcontrollogfile (set boinctempcontroloutputpart1=No value read from ini using default logfile)
if not defined boinctempcontrollogfile (set boinctempcontroloutputpart2=value: %defboinctempcontrollogfile%)
if not defined boinctempcontrollogfile call :eocuhtotheline
if not defined boinctempcontrollogfile (set boinctempcontrollogfile=%defboinctempcontrollogfile%)

rem set default delay in seconds for output review value
if not defined boinctempcontroloutputreviewdelay (set boinctempcontroloutputpart1=No value read from ini using default outputreviewdelay)
if not defined boinctempcontroloutputreviewdelay (set boinctempcontroloutputpart2=value: %defboinctempcontroloutputreviewdelay%)
if not defined boinctempcontroloutputreviewdelay call :eocuhtotheline
if not defined boinctempcontroloutputreviewdelay (set boinctempcontroloutputreviewdelay=%defboinctempcontroloutputreviewdelay%)

rem set default output message level value
if not defined boinctempcontroloutputmessagelevel (set boinctempcontroloutputpart1=No value read from ini using default outputmessagelevel)
if not defined boinctempcontroloutputmessagelevel (set boinctempcontroloutputpart2=value: %defboinctempcontroloutputmessagelevel%)
if not defined boinctempcontroloutputmessagelevel call :eocuhtotheline
if not defined boinctempcontroloutputmessagelevel (set boinctempcontroloutputmessagelevel=%defboinctempcontroloutputmessagelevel%)

rem set debug run wget commands value
if not defined boinctempcontrolrunwgetcmd (set boinctempcontroloutputpart1=No value read from ini using default runwgetcmd)
if not defined boinctempcontrolrunwgetcmd (set boinctempcontroloutputpart2=value: %defboinctempcontrolrunwgetcmd%)
if %boinctempcontroloutputmessagelevel% GTR 2 (
if not defined boinctempcontrolrunwgetcmd call :eocuhtotheline
rem if %boinctempcontroloutputmessagelevel% GTR 2 (
)
if not defined boinctempcontrolrunwgetcmd (set boinctempcontrolrunwgetcmd=%defboinctempcontrolrunwgetcmd%)

rem set debug run boinccmd commands value
if not defined boinctempcontrolrunboinccmd (set boinctempcontroloutputpart1=No value read from ini using default runboinccmd)
if not defined boinctempcontrolrunboinccmd (set boinctempcontroloutputpart2=value: %defboinctempcontrolrunboinccmd%)
if %boinctempcontroloutputmessagelevel% GTR 2 (
if not defined boinctempcontrolrunboinccmd call :eocuhtotheline
rem if %boinctempcontroloutputmessagelevel% GTR 2 (
)
if not defined boinctempcontrolrunboinccmd (set boinctempcontrolrunboinccmd=%defboinctempcontrolrunboinccmd%)
echo Processing Control ini file Complete
rem goto :processitweather
rem goto :dontrun
if x%boinctempcontrolrunonlyonce% EQU xyes (
if  x%boinctempcontroldelayprogram% EQU xchoice (
if NOT exist %boinctempcontrolchoicedirectoryprogram% (
echo Did not find choice.exe program.
echo Need choice.exe or choose.exe program for processing delay
echo.
echo You can download choose.exe program.
echo Site: http://www.westmesatech.com/editv.html
exit
rem if NOT exist %boinctempcontrolchoicedirectoryprogram% (
)
rem if  x%boinctempcontroldelayprogram% EQU xchoice (
)
rem if x%boinctempcontrolrunonlyonce% EQU xyes (
)
echo (..  ..  ..  ..  ..  ..  ..  ..)
echo (  ..  ..  ..  ..  ..  ..  ..  )
echo %date% %time%
echo Run program %currentboinctempcontrolprogramcmd%
echo Located in directory: %currentboinctempcontroldirectory%
echo Ver. %pgmver%
echo (..  ..  ..  ..  ..  ..  ..  ..)
echo (  ..  ..  ..  ..  ..  ..  ..  )
echo.
set /A boinctempcontrolwintaskcount=0
:chechforboincagain
set boinctempcontrolwintask=tasklist /fi "imagename eq boinc.exe"
FOR /f "tokens=1,2,3 delims=<space>" %%G IN ('%boinctempcontrolwintask% ^| find /i /c "boinc.exe"') DO set boinctempcontrolboincexecnt=%%G
set /A boinctempcontrolwintaskcount=boinctempcontrolwintaskcount+1
if %boinctempcontrolwintaskcount% GEQ 20 goto :boincnotfound
if %boinctempcontrolboincexecnt% equ 0 goto :chechforboincagain
:boincnotfound
if %boinctempcontrolboincexecnt% equ 0 echo Boinc.exe is not running.
rem if %boinctempcontrolboincexecnt% equ 0 goto :error
if %boinctempcontrolboincexecnt% equ 0 goto :waitfornextrun
echo --- ---
set boinctempcontrolboincversion=%boinctempcontrolboinccmddirectoryprogram% --version
FOR /f "tokens=1,2,3,4,5" %%G IN ('%boinctempcontrolboincversion%') DO set boincversion=%%K
echo Boinc Version: %boincversion%

if x%boinctempcontrolstoprun% EQU xyes (
echo Stop run equals yes
echo ending run
goto :dontrun
rem if x%boinctempcontrolstoprun% EQU xyes (
)
echo --- ---
echo Retrieve weather info for: %boinctempcontrolweatherloc%
echo Using WGet program:  %boinctempcontrolwgetdirectoryprogram%
echo Using boinccmd program:  %boinctempcontrolboinccmddirectoryprogram%
echo Using boinc data directory:  %boinctempcontrolboincdatadirectory%

if %boinctempcontrolboincexecnt% equ 0 goto :waitfornextrun

echo --- ---
if %boinctempcontroloutputmessagelevel% GTR 3  echo WGet url %boinctempcontrolweatherurl%
set wgettorun=%boinctempcontrolwgetdirectoryprogram% %boinctempcontrolwgetoptions% %boinctempcontrolweatherurl% -O %boinctempcontrolweatherinfofile%
if %boinctempcontroloutputmessagelevel% GTR 3 echo Wget command: %wgettorun%
if x%boinctempcontrolrunwgetcmd% EQU xyes (
echo Executing WGet
%boinctempcontrolruncomdtext% %wgettorun%
rem if x%boinctempcontrolrunwgetcmd% EQU xyes (
)

if exist %boinctempcontrolweatherinfofile% (
if %boinctempcontroloutputmessagelevel% GTR 3 echo --- ---
FOR /F "tokens=1,2,3 delims=<>=" %%A IN ('type %boinctempcontrolweatherinfofile%') DO (
call :processweather %%A %%B  %%C
)
rem if exist %boinctempcontrolweatherinfofile% (
)
if NOT exist %boinctempcontrolweatherinfofile% (
if %boinctempcontroloutputmessagelevel% GTR 3 echo --- ---
echo Weather file is not found
echo Verify wget command ran to produce this %boinctempcontrolweatherinfofile% file
echo Exiting
goto :dontrun
rem if NOT exist %boinctempcontrolweatherinfofile% (
)
echo --- ---
if !boinctempcontroltemperature! NEQ 1000 (
if %boinctempcontroloutputmessagelevel% GTR 3 echo temperature=pct=%boinctempcontroltemperature%=excl=!boinctempcontroltemperature!=end
call :breaknumberbydecimalpoint boinctempcontroltemperaturebeforedp boinctempcontroltemperatureafterdp boinctempcontroltemperatureafterdplength %boinctempcontroltemperature%
if x%boinctempcontroltemperatureafterdp% EQU xnovalue (set boinctempcontroltemperatureafterdp=)
if %boinctempcontroloutputmessagelevel% GTR 3 echo temperature before dp=pct=%boinctempcontroltemperaturebeforedp%=excl=!boinctempcontroltemperaturebeforedp!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo temperature after dp=pct=%boinctempcontroltemperatureafterdp%=excl=!boinctempcontroltemperatureafterdp!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo temperature after dp length=pct=%boinctempcontroltemperatureafterdplength%=excl=!boinctempcontroltemperatureafterdplength!=end
echo Boinc suspend temperature: %boinctempcontroltemptosuspend%
call :breaknumberbydecimalpoint boinctempcontroltemptosuspendbeforedp boinctempcontroltemptosuspendafterdp boinctempcontroltemptosuspendafterdplength %boinctempcontroltemptosuspend%
if x%boinctempcontroltemptosuspendafterdp% EQU xnovalue (set boinctempcontroltemptosuspendafterdp=)
if %boinctempcontroloutputmessagelevel% GTR 3 echo temptosuspendnum before dp=pct=%boinctempcontroltemptosuspendbeforedp%=excl=!boinctempcontroltemptosuspendbeforedp!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo temptosuspendnum after dp=pct=%boinctempcontroltemptosuspendafterdp%=excl=!boinctempcontroltemptosuspendafterdp!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo temptosuspendnum after dp length=pct=%boinctempcontroltemptosuspendafterdplength%=excl=!boinctempcontroltemptosuspendafterdplength!=end
echo Boinc resume temperature: %boinctempcontroltemptoresume%
call :breaknumberbydecimalpoint boinctempcontroltemptoresumebeforedp boinctempcontroltemptoresumeafterdp boinctempcontroltemptoresumeafterdplength %boinctempcontroltemptoresume%
if x%boinctempcontroltemptosuspendafterdp% EQU xnovalue (set boinctempcontroltemptosuspendafterdp=)
if %boinctempcontroloutputmessagelevel% GTR 3 echo temptoresumenum before dp=pct=%boinctempcontroltemptoresumebeforedp%=excl=!boinctempcontroltemptoresumebeforedp!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo temptoresumenum after dp=pct=%boinctempcontroltemptoresumeafterdp%=excl=!boinctempcontroltemptoresumeafterdp!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo temptoresumenum after dp length=pct=%boinctempcontroltemptoresumeafterdplength%=excl=!boinctempcontroltemptoresumeafterdplength!=end
if x%boinctempcontrolrunonlyonce% NEQ xyes (
if not exist ".\%currentboinctempcontrolprogram%-suspend-status.txt" (
call :boinctempsuspendedmsg %boinctempcontroltempsuspended%
rem if not exist ".\%currentboinctempcontrolprogram%-suspend-status.txt" (
)
rem if x%boinctempcontrolrunonlyonce% NEQ xyes (
)
rem if %boinctempcontroltemperature% NEQ 1000 (
)
if %boinctempcontroltemperature% NEQ 1000 (
if %boinctempcontroloutputmessagelevel% GTR 3  echo Suspend code
if %boinctempcontroltemperatureafterdplength% NEQ %boinctempcontroltemptosuspendafterdplength% (
if %boinctempcontroltemperatureafterdplength% GTR %boinctempcontroltemptosuspendafterdplength% (
set /A x1afterdplengthtoadd=boinctempcontroltemperatureafterdplength-boinctempcontroltemptosuspendafterdplength
for /L %%C in (1,1,!x1afterdplengthtoadd!) DO set boinctempcontroltemptosuspendafterdp=!boinctempcontroltemptosuspendafterdp!0
call :strlen boinctempcontroltemptosuspendafterdplength !boinctempcontroltemptosuspendafterdp!
rem if %boinctempcontroltemperatureafterdplength% GTR %boinctempcontroltemptosuspendafterdplength% (
)
if %boinctempcontroltemptosuspendafterdplength% GTR %boinctempcontroltemperatureafterdplength% (
set /A x2afterdplengthtoadd=boinctempcontroltemptosuspendafterdplength-boinctempcontroltemperatureafterdplength
for /L %%C in (1,1,!x2afterdplengthtoadd!) DO set boinctempcontroltemperatureafterdp=!boinctempcontroltemperatureafterdp!0
call :strlen boinctempcontroltemperatureafterdplength !boinctempcontroltemperatureafterdp!
rem if %boinctempcontroltemptosuspendafterdplength% GTR %boinctempcontroltemperatureafterdplength% (
)
rem if %boinctempcontroltemperatureafterdplength% NEQ %boinctempcontroltemptosuspendafterdplength% (
)
rem if %boinctempcontroltemperature% NEQ 1000 (
)
if %boinctempcontroltemperature% NEQ 1000 (

if %boinctempcontroltemperaturebeforedp% GTR %boinctempcontroltemptosuspendbeforedp% (
call :suspendboinccmdprocessing
rem if %boinctempcontroltemperaturebeforedp% GTR %boinctempcontroltemptosuspendbeforedp% (
)
if %boinctempcontroltemperaturebeforedp% LSS %boinctempcontroltemptosuspendbeforedp% (
set /A boinctempcontrolmatchoftemptosuspendrun=0
rem if %boinctempcontroltemperaturebeforedp% LSS %boinctempcontroltemptosuspendbeforedp% (
)
if %boinctempcontroltemperaturebeforedp% EQU %boinctempcontroltemptosuspendbeforedp% (
if %boinctempcontroltemperatureafterdp% GTR %boinctempcontroltemptosuspendafterdp% (
call :suspendboinccmdprocessing
rem if %boinctempcontroltemperatureafterdp% GTR %boinctempcontroltemptosuspendafterdp% (
)
if %boinctempcontroltemperatureafterdp% LSS %boinctempcontroltemptosuspendafterdp% (
set /A boinctempcontrolmatchoftemptosuspendrun=0
rem if %boinctempcontroltemperatureafterdp% LSS %boinctempcontroltemptosuspendafterdp% (
)
rem if %boinctempcontroltemperaturebeforedp% EQU %boinctempcontroltemptosuspendbeforedp% (
)
if %boinctempcontroloutputmessagelevel% GTR 3  echo Resume code
if %boinctempcontroltemperatureafterdplength% NEQ %boinctempcontroltemptoresumeafterdplength% (
if %boinctempcontroltemperatureafterdplength% GTR %boinctempcontroltemptoresumeafterdplength% (
set /A x1afterdplengthtoadd=boinctempcontroltemperatureafterdplength-boinctempcontroltemptoresumeafterdplength
for /L %%C in (1,1,!x1afterdplengthtoadd!) DO set boinctempcontroltemptoresumeafterdp=!boinctempcontroltemptoresumeafterdp!0
call :strlen boinctempcontroltemptoresumeafterdplength !boinctempcontroltemptoresumeafterdp!
rem if %boinctempcontroltemperatureafterdplength% GTR %boinctempcontroltemptoresumeafterdplength% (
)
if %boinctempcontroltemptoresumeafterdplength% GTR %boinctempcontroltemperatureafterdplength% (
set /A x2afterdplengthtoadd=boinctempcontroltemptoresumeafterdplength-boinctempcontroltemperatureafterdplength
for /L %%C in (1,1,!x2afterdplengthtoadd!) DO set boinctempcontroltemperatureafterdp=!boinctempcontroltemperatureafterdp!0
call :strlen boinctempcontroltemperatureafterdplength !boinctempcontroltemperatureafterdp!
rem if %boinctempcontroltemptoresumeafterdplength% GTR %boinctempcontroltemperatureafterdplength% (
)
rem if %boinctempcontroltemperatureafterdplength% NEQ %boinctempcontroltemptosuspendafterdplength% (
)
if %boinctempcontroloutputmessagelevel% GTR 3 echo temperature resume code LSS before dp=pct=%boinctempcontroltemperaturebeforedp%=excl=!boinctempcontroltemperaturebeforedp!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo temperature resume code LSS after dp=pct=%boinctempcontroltemperatureafterdp%=excl=!boinctempcontroltemperatureafterdp!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo temperature resume code LSS after dp length=pct=%boinctempcontroltemperatureafterdplength%=excl=!boinctempcontroltemperatureafterdplength!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo temptosuspend resume code LSS before dp=pct=%boinctempcontroltemptosuspendbeforedp%=excl=!boinctempcontroltemptosuspendbeforedp!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo temptosuspend resume code LSS after dp=pct=%boinctempcontroltemptosuspendafterdp%=excl=!boinctempcontroltemptosuspendafterdp!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo temptosuspend resume code LSS after dp length=pct=%boinctempcontroltemptosuspendafterdplength%=excl=!boinctempcontroltemptosuspendafterdplength!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo temptoresume resume code LSS before dp=pct=%boinctempcontroltemptoresumebeforedp%=excl=!boinctempcontroltemptoresumebeforedp!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo temptoresume resume code LSS after dp=pct=%boinctempcontroltemptoresumeafterdp%=excl=!boinctempcontroltemptoresumeafterdp!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo temptoresume resume code LSS after dp length=pct=%boinctempcontroltemptoresumeafterdplength%=excl=!boinctempcontroltemptoresumeafterdplength!=end
if %boinctempcontroltemperaturebeforedp% LSS %boinctempcontroltemptoresumebeforedp% (
call :resumeboincprocessing
rem if %boinctempcontroltemperaturebeforedp% LSS %boinctempcontroltemptoresumebeforedp% (
)
if %boinctempcontroltemperaturebeforedp% GTR %boinctempcontroltemptoresumebeforedp% (
set /A boinctempcontrolmatchoftemptoresumerun=0
rem if %boinctempcontroltemperaturebeforedp% GTR %boinctempcontroltemptoresumebeforedp% (
)
if %boinctempcontroltemperaturebeforedp% EQU %boinctempcontroltemptoresumebeforedp% (
if %boinctempcontroltemperatureafterdp% LSS %boinctempcontroltemptoresumeafterdp% (
call :resumeboincprocessing
rem if %boinctempcontroltemperatureafterdp% LSS %boinctempcontroltemptoresumeafterdp% (
)
if %boinctempcontroltemperatureafterdp% GTR %boinctempcontroltemptoresumeafterdp% (
set /A boinctempcontrolmatchoftemptoresumerun=0
rem if %boinctempcontroltemperatureafterdp% GTR %boinctempcontroltemptoresumeafterdp% (
)
rem if %boinctempcontroltemperaturebeforedp% EQU %boinctempcontroltemptoresumebeforedp% (
)
rem if %boinctempcontroltemperature% NEQ 1000 (
)
:waitfornextrun
echo --- ---
if x%boinctempcontrolrunonlyonce% NEQ xyes (
echo %date% %time%
if  x%boinctempcontroldelayprogram% EQU xchoice (
if exist %boinctempcontrolchoicedirectoryprogram% CHOICE.exe /N /D Y /T %boinctempcontrolrunagaindelay% /M "Run Again? [Y]/N (wait %boinctempcontrolrunagaindelay% secs):"
)
if  x%boinctempcontroldelayprogram% EQU xchoose (
if exist %boinctempcontrolchoosedirectoryprogram% %boinctempcontrolchoosedirectoryprogram% -d Y -n -p "Run Again? [Y]/N (wait %boinctempcontrolrunagaindelay% secs): "  -t Y,%boinctempcontrolrunagaindelay%
)
rem if n exit
if errorlevel 2 goto :dontrun
rem if y run it again
if errorlevel 1 goto :clearvaluesfornextrun
rem if x%boinctempcontrolrunonlyonce% EQU xyes (
)
goto :dontrun

:clearvaluesfornextrun
(set boinctempcontroldelayprogram=)
(set boinctempcontrolchoosedirectoryprogram=)
(set boinctempcontrolchoicedirectoryprogram=)
(set boinctempcontrolrunonlyonce=)
(set boinctempcontrolrunagaindelay=)
(set boinctempcontrolboincresumeoption=)
(set boinctempcontrolwgetfinaldirectoryprogram=)
(set boinctempcontrolwgetoptions=)
(set boinctempcontrolweatherloc=)
(set boinctempcontrolweatherunits=)
(set boinctempcontrolweatherurl=)
(set boinctempcontrolweatherinfofile=)
(set boinctempcontroltemptosuspend=)
(set boinctempcontroltemptoresume=)
rem (set boinctempcontroltempsuspended=)
(set boinctempcontrollogtempevents=)
(set boinctempcontrollogfile=)
(set boinctempcontrolrunonlyonce=)
(set boinctempcontrolstoprun=)
(set boinctempcontroloutputmessagelevel=)
(set boinctempcontrolsubroutinemsg=)
(set boinctempcontrolrunwgetcmd=)
(set boinctempcontrolrunboinccmd=)
goto :runtemperaturecheckagain

:processarginput
if [%subroutinemsg%] EQU [yes] echo entering processarginput
 rem waiting
rem echo Processing lookfor=%1=defvalneeded=%2=end
:: length of parse arg
set boinctempcontrolarglen=0
set boinctempcontrollookingfor=%1
set defboinctempcontrolparseargvalneeded=%2
set boinctempcontroloktosetvaluetoparms=%4

:finddelim
for /F %%n in ('@echo %%boinctempcontrollookingfor:~%boinctempcontrolarglen%^,1%%') do set boinctempcontrolparseargchardelim=%%n
rem echo chardelim=%boinctempcontrolparseargchardelim%=end

if %boinctempcontrolarglen% GEQ 60 echo Problem have not found delimiter in less the 60 characters current arg location %boinctempcontrolarglen%
if %boinctempcontrolarglen% GEQ 60 exit /b
set /a boinctempcontrolarglen=%boinctempcontrolarglen% + 1

If "%boinctempcontrolparseargchardelim%" EQU "ECHO" goto :havedelim
set boinctempcontrolparseargdelim=%boinctempcontrolparseargchardelim%
rem echo in loop argdelim=%boinctempcontrolparseargdelim%=argdelimend
goto :finddelim

:havedelim
rem echo parseargdelim=%boinctempcontrolparseargdelim%=end
set boinctempcontrolarglen=0

:lengthparsearg
for /F %%n in ('@echo %%boinctempcontrollookingfor:~%boinctempcontrolarglen%^,1%%') do set boinctempcontrolchar=%%n
rem echo %boinctempcontrolchar%

if %boinctempcontrolarglen% GEQ 80 echo There is a problem did search to column 80 and did not find the delimiter=: in %boinctempcontrollookingfor%. Exiting
if %boinctempcontrolarglen% GEQ 80 echo char=%boinctempcontrolparseargchar% len=%boinctempcontrolparsearglen% delim=%boinctempcontrolparseargdelim%
if %boinctempcontrolarglen% GEQ 80 goto :eof
set /a boinctempcontrolarglen=%boinctempcontrolarglen% + 1
If "%boinctempcontrolchar%" NEQ "%boinctempcontrolparseargdelim%" goto :lengthparsearg

rem echo after :lengthparsearg lookingfor=%boinctempcontrollookingfor%=length=%boinctempcontrolarglen%=lengthend

if not defined boinctempcontrolparseargprm1 goto :skipparseargvalue2
call :processarginputcheckme checkme1 %boinctempcontrolparseargprm1%
:skipparseargvalue2
if not defined boinctempcontrolparseargprm2 goto :skipparseargvalue3
call :processarginputcheckme checkme2 %boinctempcontrolparseargprm2%
:skipparseargvalue3
if not defined boinctempcontrolparseargprm3 goto :skipparseargvalue4
call :processarginputcheckme checkme3 %boinctempcontrolparseargprm3%
:skipparseargvalue4
if not defined boinctempcontrolparseargprm4 goto :skipparseargvalue5
call :processarginputcheckme checkme4 %boinctempcontrolparseargprm4%
:skipparseargvalue5
if not defined boinctempcontrolparseargprm5 goto :skipparseargvalue6
call :processarginputcheckme checkme5 %boinctempcontrolparseargprm5%
:skipparseargvalue6
if not defined boinctempcontrolparseargprm6 goto :skipparseargvalue7
call :processarginputcheckme checkme6 %boinctempcontrolparseargprm6%
:skipparseargvalue7
if not defined boinctempcontrolparseargprm7 goto :skipparseargvalue8
call :processarginputcheckme checkme7 %boinctempcontrolparseargprm7%
:skipparseargvalue8
if not defined boinctempcontrolparseargprm8 goto :skipparseargvalue9
call :processarginputcheckme checkme8 %boinctempcontrolparseargprm8%
:skipparseargvalue9
if not defined boinctempcontrolparseargbegval goto :skipparseargnovalue
call set boinctempcontrolcheckmebeg=%%boinctempcontrolparseargbegval:~0,%boinctempcontrolarglen%%%
rem echo checkmebeg=%boinctempcontrolcheckmebeg%=checkmebegend
if x%boinctempcontrolcheckmebeg% EQU x%boinctempcontrollookingfor% (call set boinctempcontrolparseargbeg=%%boinctempcontrolparseargbegval:~0,%boinctempcontrolarglen%%%)
if x%boinctempcontrolcheckmebeg% EQU x%boinctempcontrollookingfor% (call set boinctempcontrolparseargval=%%boinctempcontrolparseargbegval:~%boinctempcontrolarglen%%%)
:skipparseargnovalue
rem echo lookfor=%boinctempcontrollookingfor%=arglen=%boinctempcontrolarglen%=begval=%boinctempcontrolparseargbegval%=beg=%boinctempcontrolparseargbeg%=varval=%boinctempcontrolparseargval%=end

if defined boinctempcontrolparseargbeg (set boinctempcontroloutputpart1=A value was passed for %boinctempcontrolparseargbeg%)
if defined boinctempcontrolparseargbeg (set boinctempcontroloutputpart2=value: %boinctempcontrolparseargval% )
call :processarginputdefined

if not defined boinctempcontrolparseargvalneeded (set boinctempcontroloutputpart1=No value was passed using default %boinctempcontrollookingfor%)
if not defined boinctempcontrolparseargvalneeded (set boinctempcontroloutputpart2=value: %defboinctempcontrolparseargvalneeded%)
call :processarginputnotdefined

call :eocuhtotheline

:afterprintmsg
if defined boinctempcontrolparseargvalneeded (set %3=%boinctempcontrolparseargvalneeded%)
if x%boinctempcontroloktosetvaluetoparms% NEQ  xoktosetvaluetoparms goto :skipsetvalueparms
if defined boinctempcontrolparseargprgmparms (set %5=%boinctempcontrolparseargprgmparms%)
:skipsetvalueparms
(set boinctempcontrolarglen=)
(set boinctempcontrollookingfor=)
(set defboinctempcontrolparseargvalneeded=)
(set boinctempcontroloktosetvaluetoparms=)
(set boinctempcontrolparseargchardelim=)
(set boinctempcontrolparseargdelim=)
(set boinctempcontrolchar=)
(set boinctempcontrolcheckmebeg=)
(set boinctempcontrolparseargbegval=)
(set boinctempcontrolparseargbeg=)
(set boinctempcontrolparseargval=)
(set boinctempcontrolparsearginputcheckmelabel=)
(set boinctempcontrolparsearginputcheckme=)
(set boinctempcontrolparseargcheckme=)
(set boinctempcontrolparseargprgmparms=)
(set boinctempcontrolparseargvalneeded=)
rem ----------------
exit /b

:processarginputcheckme
if x%subroutinemsg% EQU xyes echo entering :processarginputcheckme
set boinctempcontrolparsearginputcheckmelabel=%1
set boinctempcontrolparsearginputcheckme=%2
rem echo inputcheckmelabel=%boinctempcontrolparsearginputcheckmelabel%=inputcheckme=%boinctempcontrolparsearginputcheckme%=inputcheckmeend=length=%boinctempcontrolarglen%=end
call set boinctempcontrolparseargcheckme=%%boinctempcontrolparsearginputcheckme:~0,%boinctempcontrolarglen%%%
if x%boinctempcontrolparseargcheckme% EQU x%boinctempcontrollookingfor% set boinctempcontrolparseargbegval=%boinctempcontrolparsearginputcheckme%
rem echo parseargcheckme=%boinctempcontrolparseargcheckme%=lookingfor=%boinctempcontrollookingfor%=parseargbegval=%boinctempcontrolparseargbegval%=end
rem leaving :processarginputcheckme
exit /b

:processarginputdefined
if x%subroutinemsg% EQU xyes echo entering :processarginputdefined
if defined boinctempcontrolparseargbeg (set boinctempcontrolparseargprgmparms=%boinctempcontrolparseargbeg%%boinctempcontrolparseargval%)
if defined boinctempcontrolparseargbeg (set boinctempcontrolparseargvalneeded=%boinctempcontrolparseargval%)
rem leaving :processarginputdefined
exit /b

:processarginputnotdefined
if x%subroutinemsg% EQU xyes echo entering :processarginputnotdefined
if not defined boinctempcontrolparseargvalneeded (set boinctempcontrolparseargprgmparms=%boinctempcontrolparsearglookingfor%%defboinctempcontrolparseargvalneeded%)
if not defined boinctempcontrolparseargvalneeded (set boinctempcontrolparseargvalneeded=%defboinctempcontrolparseargvalneeded%)
rem leaving :processarginputnotdefined
exit /b

:processcontrolini
if x%subroutinemsg% EQU xyes echo entering :processcontrolini
rem echo processcontrolini area=1=%1=2=%2=3=%3=end
if /I x%1 EQU xrem exit /b
set readfrom=ini
set boinctempcontrolinfofound=no
if /I x%1 EQU xstoprun call :processsetvalue2items  %1 %defboinctempcontrolstoprun% %2 lo  boinctempcontrolstoprun
if /I x%1 EQU xstoprun set boinctempcontrolinfofound=yes
rem if /I x%1 EQU xwgetinstalldirectory echo on
if /I x%1 EQU xwgetinstalldirectory call :processsetvalue2items  %1 %defboinctempcontrolwgetinstalldirectory% %2 no boinctempcontrolwgetinstalldirectory
if /I x%1 EQU xwgetinstalldirectory call :processcontroldirectoryslash boinctempcontrolwgetinstalldirectory %boinctempcontrolwgetinstalldirectory%
if /I x%1 EQU xwgetinstalldirectory set boinctempcontrolinfofound=yes
rem if /I x%1 EQU xwgetinstalldirectory echo off
rem if /I x%1 EQU xboinccmddirectoryprogram echo on
if /I x%1 EQU xboinccmddirectoryprogram call :processsetvalue2items  %1 %defboinctempcontrolboinccmddirectoryprogram% %2 no boinctempcontrolboinccmddirectoryprogram
if /I x%1 EQU xboinccmddirectoryprogram set boinctempcontrolinfofound=yes
rem if /I x%1 EQU xboinccmddirectoryprogram echo off
rem if /I x%1 EQU xboincdatadirectory echo on
if /I x%1 EQU xboincdatadirectory call :processsetvalue2items  %1 %defboinctempcontrolboincdatadirectory% %2 no boinctempcontrolboincdatadirectory
if /I x%1 EQU xboincdatadirectory call :processcontroldirectoryslash boinctempcontrolboincdatadirectory %boinctempcontrolboincdatadirectory%
if /I x%1 EQU xboincdatadirectory set boinctempcontrolinfofound=yes
rem if /I x%1 EQU xboincdatadirectory echo off
if /I x%1 EQU xdelayprogram call :processsetvalue2items  %1 %defboinctempcontroldelayprogram% %2 lo boinctempcontroldelayprogram
if /I x%1 EQU xdelayprogram set boinctempcontrolinfofound=yes
if /I x%1 EQU xchoosedirectoryprogram call :processsetvalue2items  %1 %defboinctempcontrolchoosedirectoryprogram% %2 no boinctempcontrolchoosedirectoryprogram
if /I x%1 EQU xchoosedirectoryprogram set boinctempcontrolinfofound=yes
if /I x%1 EQU xchoicedirectoryprogram call :processsetvalue2items  %1 %defboinctempcontrolchoicedirectoryprogram% %2 no boinctempcontrolchoicedirectoryprogram
if /I x%1 EQU xchoicedirectoryprogram set boinctempcontrolinfofound=yes
if /I x%1 EQU xrunonlyonce call :processsetvalue2items  %1 %defboinctempcontrolrunonlyonce% %2 lo boinctempcontrolrunonlyonce
if /I x%1 EQU xrunonlyonce set boinctempcontrolinfofound=yes
if /I x%1 EQU xrunagaindelay call :processsetvalue2items  %1 %defboinctempcontrolrunagaindelay% %2 no boinctempcontrolrunagaindelay
if /I x%1 EQU xrunagaindelay set boinctempcontrolinfofound=yes
if /I x%1 EQU xboincresumeoption call :processsetvalue2items  %1 %defboinctempcontrolboincresumeoption% %2 no boinctempcontrolboincresumeoption
if /I x%1 EQU xboincresumeoption set boinctempcontrolinfofound=yes
if /I x%1 EQU xwgetfinaldirectoryprogram call :processsetvalue2items  %1 %defboinctempcontrolwgetfinaldirectoryprogram% %2 no boinctempcontrolwgetfinaldirectoryprogram
if /I x%1 EQU xwgetfinaldirectoryprogram set boinctempcontrolinfofound=yes
rem if /I x%1 EQU xweatherloc echo on
if /I x%1 EQU xwgetoptions call :processsetvalue2items  %1 %defboinctempcontrolwgetoptions% %2 no boinctempcontrolwgetoptions
if /I x%1 EQU xwgetoptions set boinctempcontrolwgetoptions=%boinctempcontrolwgetoptions:"=%
if /I x%1 EQU xwgetoptions set boinctempcontrolinfofound=yes
if /I x%1 EQU xweatherloc call :processsetvalue2items  %1 %defboinctempcontrolweatherloc% %2 no boinctempcontrolweatherloc
if /I x%1 EQU xweatherloc set boinctempcontrolweatherloc=%boinctempcontrolweatherloc:"=%
if /I x%1 EQU xweatherloc set boinctempcontrolinfofound=yes
rem if /I x%1 EQU xweatherloc echo off
if /I x%1 EQU xweatherunits call :processsetvalue2items  %1 %defboinctempcontrolweatherunits% %2 no boinctempcontrolweatherunits
rem if /I x%1 EQU xweatherunits  call set
if /I x%1 EQU xweatherunits set boinctempcontrolinfofound=yes
if /I x%1 EQU xweatherurl call :processsetvalue2items  %1 %defboinctempcontrolweatherurl% %2 no boinctempcontrolweatherurl
if /I x%1 EQU xweatherurl set boinctempcontrolinfofound=yes
if /I x%1 EQU xweatherinfofile call :processsetvalue2items  %1 %defboinctempcontrolweatherinfofile% %2 no boinctempcontrolweatherinfofile
if /I x%1 EQU xweatherinfofile set boinctempcontrolinfofound=yes
if /I x%1 EQU xtemptosuspend call :processsetvalue2items  %1 %defboinctempcontroltemptosuspend% %2 no boinctempcontroltemptosuspend
if /I x%1 EQU xtemptosuspend set boinctempcontrolinfofound=yes
if /I x%1 EQU xmatchoftemptosuspend call :processsetvalue2items  %1 %defboinctempcontrolmatchoftemptosuspend% %2 no boinctempcontrolmatchoftemptosuspend
if /I x%1 EQU xmatchoftemptosuspend set boinctempcontrolinfofound=yes
if /I x%1 EQU xtemptoresume call :processsetvalue2items  %1 %defboinctempcontroltemptoresume% %2 no boinctempcontroltemptoresume
if /I x%1 EQU xtemptoresume set boinctempcontrolinfofound=yes
if /I x%1 EQU xmatchoftemptoresume call :processsetvalue2items  %1 %defboinctempcontrolmatchoftemptoresume% %2 no boinctempcontrolmatchoftemptoresume
if /I x%1 EQU xmatchoftemptoresume set boinctempcontrolinfofound=yes
if /I x%1 EQU xtempsuspended call :processsetvalue2items  %1 %defboinctempcontroltempsuspended% %2 no boinctempcontroltempsuspended
if /I x%1 EQU xtempsuspended set boinctempcontrolinfofound=yes
if /I x%1 EQU xlogtempevents call :processsetvalue2items  %1 %defboinctempcontrollogtempevents% %2 no boinctempcontrollogtempevents
if /I x%1 EQU xlogtempevents set boinctempcontrolinfofound=yes
if /I x%1 EQU xlogfile call :processsetvalue2items  %1 %defboinctempcontrollogfile% %2 no boinctempcontrollogfile
if /I x%1 EQU xlogfile set boinctempcontrolinfofound=yes
if /I x%1 EQU xoutputreviewdelay call :processsetvalue2items  %1 %defboinctempcontroloutputreviewdelay% %2 no boinctempcontroloutputreviewdelay
if /I x%1 EQU xoutputreviewdelay set boinctempcontrolinfofound=yes
if /I x%1 EQU xoutputmessagelevel call :processsetvalue2items  %1 %defboinctempcontroloutputmessagelevel% %2 no boinctempcontroloutputmessagelevel
if /I x%1 EQU xoutputmessagelevel set boinctempcontrolinfofound=yes
if /I x%1 EQU xsubroutinemsg call :processsetvalue2items  %1 %defboinctempcontrolsubroutinemsg% %2 no boinctempcontrolsubroutinemsg
if /I x%1 EQU xsubroutinemsg set boinctempcontrolinfofound=yes
if /I x%1 EQU xrunwgetcmd call :processsetvalue2items  %1 %defboinctempcontrolrunwgetcmd% %2 no boinctempcontrolrunwgetcmd
if /I x%1 EQU xrunwgetcmd set boinctempcontrolinfofound=yes
if /I x%1 EQU xrunboinccmd call :processsetvalue2items  %1 %defboinctempcontrolrunboinccmd% %2 no boinctempcontrolrunboinccmd
if /I x%1 EQU xrunboinccmd set boinctempcontrolinfofound=yes
if /I x%boinctempcontrolinfofound% equ xno echo This %1 was not processed
exit /b

:processcontroldirectoryslash
if x%subroutinemsg% EQU xyes echo entering :locatedecimalpoint
set boinctempcontrolprocesscontroldir=%~2
if not defined boinctempcontrolprocesscontroldirwithquotes set boinctempcontrolprocesscontroldirwithquotes=no
rem echo boinctempcontrolprocesscontroldir pct=%boinctempcontrolprocesscontroldir%=end
call :strlen boinctempcontrolprocesscontroldirlength %boinctempcontrolprocesscontroldir%
set /A boinctempcontrolprocesscontroldirlengthcharstrt=boinctempcontrolprocesscontroldirlength
call set boinctempcontrolprocesscontroldirlengthchar=%%boinctempcontrolprocesscontroldir:~%boinctempcontrolprocesscontroldircharstrt%,1%%
rem echo boinctempcontrolprocesscontroldirlengthchar pct=%boinctempcontrolprocesscontroldirlengthchar%=end
if "x%boinctempcontrolprocesscontroldirlengthchar%" NEQ "x\" set boinctempcontrolprocesscontroldir="%boinctempcontrolprocesscontroldir:"=%\"
rem echo boinctempcontrolprocesscontroldir pct=%boinctempcontrolprocesscontroldir%=end
set %1=%boinctempcontrolprocesscontroldir%
exit /b

:locatedecimalpoint
if x%subroutinemsg% EQU xyes echo entering :locatedecimalpoint
set boinctempcontrolnumberlen=0
set boinctempcontrollookthrunumber=%~2
set boinctempcontrollookthrunumberlength=%3

:finddecimalpoint
for /F %%n in ('@echo %%boinctempcontrollookthrunumber:~%boinctempcontrolnumberlen%^,1%%') do set boinctempcontrolnumberchar=%%n
rem echo chardelim=%boinctempcontrolparseargchardelim%=end

rem if %boinctempcontrolnumberlen% GEQ %boinctempcontrollookthrunumberlength% echo Problem have not found decimal point in less the %boinctempcontrollookthrunumberlength% characters current arg location %boinctempcontrolnumberlen%
if %boinctempcontrolnumberlen% GEQ %boinctempcontrollookthrunumberlength% set %~1=0
if %boinctempcontrolnumberlen% GEQ %boinctempcontrollookthrunumberlength% exit /b
set /a boinctempcontrolnumberlen=%boinctempcontrolnumberlen% + 1

If "%boinctempcontrolnumberchar%" EQU "." goto :havedecimalpoint
set boinctempcontrolparseargdelim=%boinctempcontrolparseargchardelim%
rem echo in loop argdelim=%boinctempcontrolparseargdelim%=argdelimend
goto :finddecimalpoint

:havedecimalpoint
set %~1=%boinctempcontrolnumberlen%
exit /b

:breaknumberbydecimalpoint
if x%subroutinemsg% EQU xyes echo entering :breaknumberbydecimalpoint
set breaknumberdpnumber=%~4
set breaknumberdpnumber=%breaknumberdpnumber:"=%
call :strlen breaknumberdpnumberlength %breaknumberdpnumber%
if %boinctempcontroloutputmessagelevel% GTR 3 echo breaknumberdpnumberlength=%breaknumberdpnumberlength%=end
call :locatedecimalpoint breaknumberdpnumberdp %breaknumberdpnumber% %breaknumberdpnumberlength%
if x!breaknumberdpnumberbeforedp! EQU x set breaknumberdpnumberbeforedp=0
if %boinctempcontroloutputmessagelevel% GTR 3 echo breaknumberdpnumberdp=%breaknumberdpnumberdp%=end
if %breaknumberdpnumberdp% GTR 0 (
set /A breaknumberdpnumbersubdplenth=breaknumberdpnumberdp-1
set /A breaknumberdpnumberafterdplength=breaknumberdpnumberlength-breaknumberdpnumberdp
if %boinctempcontroloutputmessagelevel% GTR 3 echo breaknumberdpnumberafterdplength=!breaknumberdpnumberafterdplength!
call set breaknumberdpnumberbeforedp=%%breaknumberdpnumber:~0,!breaknumberdpnumbersubdplenth!%%
if %boinctempcontroloutputmessagelevel% GTR 3 echo breaknumberdpnumberbeforedp=!breaknumberdpnumberbeforedp!
call set breaknumberdpnumberafterdp=%%breaknumberdpnumber:~!breaknumberdpnumberdp!%%
if %boinctempcontroloutputmessagelevel% GTR 3 echo breaknumberdpnumberafterdp=!breaknumberdpnumberafterdp!
rem if %breaknumberdpnumberdp% GTR 0 (
) else (
call set breaknumberdpnumberbeforedp=%breaknumberdpnumber%
if %boinctempcontroloutputmessagelevel% GTR 3 echo breaknumberdpnumberbeforedp=!breaknumberdpnumberbeforedp!
(set breaknumberdpnumberafterdp=novalue)
set breaknumberdpnumberafterdplength=0
rem if %breaknumberdpnumberdp% GTR 0 ) else (
)
set %~1=%breaknumberdpnumberbeforedp%
set %~2=%breaknumberdpnumberafterdp%
set %~3=%breaknumberdpnumberafterdplength%
exit /b

:boinctempsuspendedmsg
if x%subroutinemsg% EQU xyes echo entering :boinctempsuspendedmsg
set suspendmsg=%~1
echo Boinc has been temperature suspended: !suspendmsg!
if %boinctempcontroloutputmessagelevel% GTR 3 echo suspend run count pct=%boinctempcontrolmatchoftemptosuspendrun%=excl=!boinctempcontrolmatchoftemptosuspendrun!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo resume run count pct=%boinctempcontrolmatchoftemptoresumerun%=excl=!boinctempcontrolmatchoftemptoresumerun!=end
echo Boinc resume option: %boinctempcontrolboincresumeoption%
exit /b

:restoresuspendstatus
if x%subroutinemsg% EQU xyes echo entering :restoresuspendstatus
if exist ".\%currentboinctempcontrolprogram%-suspend-count.txt" (
FOR /F "tokens=1" %%A IN ('type ".\%currentboinctempcontrolprogram%-suspend-count.txt"') DO set boinctempcontrolmatchoftemptosuspendrun=%%A
del ".\%currentboinctempcontrolprogram%-suspend-count.txt"
rem if exist ".\%currentboinctempcontrolprogram%-suspend-count.txt" (
)
if exist ".\%currentboinctempcontrolprogram%-resume-count.txt" (
FOR /F "tokens=1" %%A IN ('type ".\%currentboinctempcontrolprogram%-resume-count.txt"') DO set boinctempcontrolmatchoftemptoresumerun=%%A
del ".\%currentboinctempcontrolprogram%-resume-count.txt"
rem if exist ".\%currentboinctempcontrolprogram%-resume-count.txt" (
)
if exist ".\%currentboinctempcontrolprogram%-suspend-status.txt" (
FOR /F "tokens=1" %%A IN ('type ".\%currentboinctempcontrolprogram%-suspend-status.txt"') DO set boinctempcontroltempsuspended=%%A
set /A boinctempcontrolmatchoftemptoresumerunchk=boinctempcontrolmatchoftemptoresumerun+1
if !boinctempcontrolmatchoftemptoresumerunchk! GEQ %boinctempcontrolmatchoftemptoresume% (
del ".\%currentboinctempcontrolprogram%-suspend-status.txt"
rem if !boinctempcontrolmatchoftemptoresumerun! GEQ %boinctempcontrolmatchoftemptoresume% (
)
call :boinctempsuspendedmsg !boinctempcontroltempsuspended!
rem if exist ".\%currentboinctempcontrolprogram%-suspend-status.txt"
)
exit /b

:suspendboinccmdprocessing
if x%subroutinemsg% EQU xyes echo entering :suspendboinccmdprocessing
rem if x%boinctempcontrolrunonlyonce% EQU xyes (
call :restoresuspendstatus
if %boinctempcontroloutputmessagelevel% GTR 3 echo tempsuspended before suspend==pct=%boinctempcontroltempsuspended%=excl=!boinctempcontroltempsuspended!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo resume run count after restore status pct=%boinctempcontrolmatchoftemptoresumerun%=excl=!boinctempcontrolmatchoftemptoresumerun!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo suspend run count after restore status pct=%boinctempcontrolmatchoftemptosuspendrun%=excl=!boinctempcontrolmatchoftemptosuspendrun!=end
if !boinctempcontrolmatchoftemptoresumerun! GTR 0 set /A  boinctempcontrolmatchoftemptoresumerun=0
if %boinctempcontroloutputmessagelevel% GTR 3 echo resume run count after restore status 2 pct=%boinctempcontrolmatchoftemptoresumerun%=excl=!boinctempcontrolmatchoftemptoresumerun!=end
rem if x%boinctempcontrolrunonlyonce% EQU xyes (
rem )

if x%boinctempcontroltempsuspended% EQU xno (
set /A boinctempcontrolmatchoftemptosuspendrun=boinctempcontrolmatchoftemptosuspendrun+1
echo Boinc temperature suspend count: !boinctempcontrolmatchoftemptosuspendrun!
if !boinctempcontrolmatchoftemptosuspendrun! GEQ %boinctempcontrolmatchoftemptosuspend% (
echo --- ---
Echo Stopping Boinc Processing
set setboincprocessing=never
set logoutputline=%date% %time% - Boinc Processing suspended - Temp: %boinctempcontroltemperature%
echo Logged: !logoutputline!
if x%boinctempcontrollogtempevents% EQU xyes echo !logoutputline!>> %boinctempcontrollogfile%
call :sendboinccmd
set /A boinctempcontrolmatchoftemptosuspendrun=0
if %boinctempcontroloutputmessagelevel% GTR 3 echo suspended before set to yes pct=%boinctempcontroltempsuspended%=excl=!boinctempcontroltempsuspended!=end
set boinctempcontroltempsuspended=yes
rem if !boinctempcontrolmatchoftemptosuspendrun! GEQ %boinctempcontrolmatchoftemptosuspend% (
)
rem if x%boinctempcontroltempsuspended% EQU xno (
)
if x%boinctempcontrolrunonlyonce% EQU xyes (
echo !boinctempcontroltempsuspended!>".\%currentboinctempcontrolprogram%-suspend-status.txt"
if !boinctempcontrolmatchoftemptosuspendrun! GTR 0 (
echo !boinctempcontrolmatchoftemptosuspendrun!>".\%currentboinctempcontrolprogram%-suspend-count.txt"
rem if !boinctempcontrolmatchoftemptosuspendrun! GTR 0 (
)
rem if x%boinctempcontrolrunonlyonce% EQU xyes (
)
exit /b

:resumeboincprocessing
if x%subroutinemsg% EQU xyes echo entering :resumeboincprocessing
rem if x%boinctempcontrolrunonlyonce% EQU xyes (
call :restoresuspendstatus
if %boinctempcontroloutputmessagelevel% GTR 3 echo tempsuspend after restore status pct=%boinctempcontroltempsuspended%=excl=!boinctempcontroltempsuspended!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo resume match count after restore status pct=%boinctempcontrolmatchoftemptoresume%=excl=!boinctempcontrolmatchoftemptoresume!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo resume run count after restore status pct=%boinctempcontrolmatchoftemptoresumerun%=excl=!boinctempcontrolmatchoftemptoresumerun!=end
if %boinctempcontroloutputmessagelevel% GTR 3 echo suspend run count after restore status pct=%boinctempcontrolmatchoftemptosuspendrun%=excl=!boinctempcontrolmatchoftemptosuspendrun!=end
if !boinctempcontrolmatchoftemptosuspendrun! GTR 0 set /A  boinctempcontrolmatchoftemptosuspendrun=0
if %boinctempcontroloutputmessagelevel% GTR 3 echo suspend run count after restore status 2 pct=%boinctempcontrolmatchoftemptosuspendrun%=excl=!boinctempcontrolmatchoftemptosuspendrun!=end
rem if x%boinctempcontrolrunonlyonce% EQU xyes (
rem )
if %boinctempcontroloutputmessagelevel% GTR 3 echo tempsuspended before if pct==pct=%boinctempcontroltempsuspended%=excl=!boinctempcontroltempsuspended!=end
if x%boinctempcontroltempsuspended% EQU xyes (
set /A boinctempcontrolmatchoftemptoresumerun=boinctempcontrolmatchoftemptoresumerun+1

if %boinctempcontroloutputmessagelevel% GTR 3 echo matchoftemptoresumerun GTR 0 pct=%boinctempcontrolmatchoftemptoresumerun%=excl=!boinctempcontrolmatchoftemptoresumerun!=end
if !boinctempcontrolmatchoftemptoresumerun! GTR 0 (
echo Boinc temperature resume count: !boinctempcontrolmatchoftemptoresumerun!
rem if !boinctempcontrolmatchoftemptoresumerun! GTR 0 (
)
if !boinctempcontrolmatchoftemptoresumerun! GEQ %boinctempcontrolmatchoftemptoresume% (
call :resumeboinccmdprocessing
set /A boinctempcontrolmatchoftemptoresumerun=0
set boinctempcontroltempsuspended=no
rem if !boinctempcontrolmatchoftemptoresumerun! GEQ %boinctempcontrolmatchoftemptoresume% (
)
rem if x%boinctempcontroltempsuspended% EQU xyes (
)
if %boinctempcontroloutputmessagelevel% GTR 3 echo tempsuspended before if excl==pct=%boinctempcontroltempsuspended%=excl=!boinctempcontroltempsuspended!=end
if x%boinctempcontroltempsuspended% EQU xno (
if x!boinctempcontroltempsuspended! EQU xyes (
set /A boinctempcontrolmatchoftemptoresumerun=boinctempcontrolmatchoftemptoresumerun+1

if !boinctempcontrolmatchoftemptoresumerun! GTR 0 (
echo Boinc temperature resume count: !boinctempcontrolmatchoftemptoresumerun!
rem if !boinctempcontrolmatchoftemptoresumerun! GTR 0 (
)
if !boinctempcontrolmatchoftemptoresumerun! GEQ %boinctempcontrolmatchoftemptoresume% (
call :resumeboinccmdprocessing
set /A boinctempcontrolmatchoftemptoresumerun=0
set boinctempcontroltempsuspended=no
rem if !boinctempcontrolmatchoftemptoresumerun! GEQ %boinctempcontrolmatchoftemptoresume% (
)
rem if x!boinctempcontroltempsuspended! EQU xyes (
)
rem if x%boinctempcontroltempsuspended% EQU xno (
)
if x%boinctempcontrolrunonlyonce% EQU xyes (
if !boinctempcontrolmatchoftemptoresumerun! GTR 0 (
echo !boinctempcontrolmatchoftemptoresumerun!>".\%currentboinctempcontrolprogram%-resume-count.txt"
rem if !boinctempcontrolmatchoftemptoresumerun! GTR 0 (
)
rem if x%boinctempcontrolrunonlyonce% EQU xyes (
)
exit /b

:resumeboinccmdprocessing
if x%subroutinemsg% EQU xyes echo entering :resumeboinccmdprocessing
echo --- ---
Echo Resuming Boinc Processing
set setboincprocessing=%boinctempcontrolboincresumeoption%
set logoutputline=%date% %time% - Boinc Processing resumed - Temp: %boinctempcontroltemperature%
echo Logged: !logoutputline!
if x%boinctempcontrollogtempevents% EQU xyes echo !logoutputline! >> %boinctempcontrollogfile%
call :sendboinccmd
exit /b

:processweather
if x%subroutinemsg% EQU xyes echo entering :processweather
rem echo processweather area=1=%1=2=%2=3=%3=end
if x%1 equ xrem exit /b
set readfrom=weather info file
set boinctempcontrolinfofound=no
if x%1 equ xtemperature call :processsetvalue2items %1 %defboincwgettemperature% %3 no boinctempcontroltemperature
if x%1 equ xtemperature set boinctempcontrolinfofound=yes
exit /b

:sendboinccmd
if x%subroutinemsg% EQU xyes echo entering :sendboinccmd
set boincinstalldir=%boincinstalldir:"=%
set boinccommand=%boinctempcontrolboinccmddirectoryprogram% --set_run_mode %setboincprocessing%
echo Command: %boinccommand%
if x%boinctempcontrolrunboinccmd% EQU xyes (
%boinctempcontrolruncomdtext% %boinccommand%
rem if x%boinctempcontrolrunboinccmd% EQU xyes (
)
exit /b

:processsetvalue2items
if x%subroutinemsg% EQU xyes echo entering :processsetvalue2items
rem echo processsetvalue2items area part1=%1=part2=%2=part3=%3=part4=%4=part5=%5=end
if x%3 NEQ x (
set processsetvalue2item=%3
if x%4 EQU xlo call :locase processsetvalue2item
if x%4 EQU xup call :upcase processsetvalue2item
(set boinctempcontroloutputpart1=A value was read from %readfrom% for %1)
set %5=!processsetvalue2item!
)
if x%3 EQU x (
set processsetvalue2item=%2
if x%4 EQU xlo call :locase processsetvalue2item
if x%4 EQU xup call :upcase processsetvalue2item
(set boinctempcontroloutputpart1=No value read from %readfrom% using default %1)
set %5=!processsetvalue2item!
)
(set boinctempcontroloutputpart2=value: !processsetvalue2item!)
rem if x%boinctempcontrolechooutputtype% EQU xcontrol (
call :eocuhtotheline
rem ) else (
rem call :eocuhtothelineaddtolist
rem )
rem ----------------
exit /b

:getregistryvalue
if x%subroutinemsg% EQU xyes echo entering getregistryvalue
(set ValueName=)
(set ValueType=)
(set ValueValue=)
FOR /F "tokens=1-5" %%A IN ('REG QUERY "%key_name%" /v "%value_name%" 2^>nul') DO (
    set ValueName=%%A
    set ValueType=%%B
    set ValueValue=%%C
    if x%%D NEQ x (set ValueValue=%%C %%D)
    if x%%E NEQ x (set ValueValue=%%C %%D %%E)
)

if defined ValueName (
    rem @echo Value Name = %ValueName%
    rem @echo Value Type = %ValueType%
    rem @echo Value Value = %ValueValue%===
    set %1="%ValueValue%"
) else (
    echo Registry key:
    @echo %key_name%\%value_name% not found.
)
exit /b

:error
echo ERROR
goto :dontrun

:reqinfo
echo ----------------
echo Command program help
echo run %currentboinctempcontrolprogramcmd%
echo        /testrun:{yes or no}
echo        /runwith:{start or call}
echo        /inidirectoryfilename:{inidirectoryandfilename}
rem ----------------
set boinctempcontrolrunwith=call
rem i am outa here
echo Exiting

:dontrun
set boinctempcontroloutputpause=no
if x%boinctempcontrolrunonlyonce% equ xyes set boinctempcontroloutputpause=yes
if x%boinctempcontroloutputpause% equ xyes (
if  x%boinctempcontroldelayprogram% EQU xchoice (
if exist %boinctempcontrolchoicedirectoryprogram% CHOICE.exe /N /D Y /T %boinctempcontroloutputreviewdelay% /M "Pausing for output review [Y]/N (Pause %boinctempcontroloutputreviewdelay% secs): "
rem if  x%boinctempcontroldelayprogram% EQU xchoice (
)
if  x%boinctempcontroldelayprogram% EQU xchoose (
if exist %boinctempcontrolchoosedirectoryprogram% %boinctempcontrolchoosedirectoryprogram% -d Y -n -p "Pausing for output review [Y]/N (Pause %boinctempcontroloutputreviewdelay% secs): "  -t Y,%boinctempcontroloutputreviewdelay%
rem if  x%boinctempcontroldelayprogram% EQU xchoose (
)
rem if x%boinctempcontroloutputpause% equ xyes (
)
(set boincvmstatusoutputpause=)
echo -------------------
echo.
echo ....
echo Exiting ...... %currentboinctempcontrolprogramcmd%

endlocal EnableDelayedExpansion

goto :eof

:eocuhtotheline
set boinctempcontrolfillerpart1=%boinctempcontroloutputpart1%%boinctempcontroloutputfiller%
(call set boinctempcontrolchoppart1=%%boinctempcontrolfillerpart1:~0,%boinctempcontrolputvaluehere%%%)
set boinctempcontrolformatpart1=%boinctempcontrolchoppart1:`= %
echo %boinctempcontrolformatpart1%%boinctempcontroloutputpart2%
rem leaving :eocuhtotheline
exit /b

:strlen
rem :strlen <resultVar> <stringVar>
rem based on function by jep
rem url http://stackoverflow.com/questions/5837418/how-do-you-get-the-string-length-in-a-batch-file   
set s=%~2
set len=0
if [!s!] NEQ [] (
set len=1
for %%P in (4096 2048 1024 512 256 128 64 32 16 8 4 2 1) do (
if [!s:~%%P^,1!] NEQ [] (
set /a len+=%%P
set s=!s:~%%P!
rem if "!s:~%%P,1!" NEQ "" (
)
rem for %%P in (4096 2048 1024 512 256 128 64 32 16 8 4 2 1) do (
)
rem if [!s!] NEQ [] (
)
set %~1=%len%
rem exit :strlen
exit /b

:processclientstateruserrunrequest
if x%subroutinemsg% EQU xyes echo entering :processclientstateruserrunrequest
if x%boinctempcontrolclientprocessed% EQU xyes (
set boinctempcontrolfindfilevalue=%boinctempcontrolfindfilevalueprev%
goto :skipclientstateread
rem
)
set boinctempcontrolfindfilevalueback=novalue
set boinctempcontrollookforthis=user_run_request
set boinctempcontrollookforthisdash=%boinctempcontrollookforthis:_=-%
set boinctempcontrollookforthis25=%boinctempcontrollookforthis:~0,25%

set boinctempcontrolclientstatus=Client State Not Found
set boinctempcontrolclientstate=%boinctempcontrolboincdatadirectory%client_state.xml
if NOT exist %boinctempcontrolclientstate% echo.
if NOT exist %boinctempcontrolclientstate% (echo Boinc Client %boinctempcontrollookforthis% Status is %boinctempcontrolclientstatus%)
if NOT exist %boinctempcontrolclientstate% (echo Boinc Client State file %boinctempcontrolclientstate%)
if exist !boinctempcontrolclientstate! goto :foundclientstate

set boinctempcontrolclientstate=%boinctempcontrolboincdatadirectory%client_state_prev.xml
if NOT exist %boinctempcontrolclientstate% echo.
if NOT exist %boinctempcontrolclientstate% (echo Boinc Client %boinctempcontrollookforthis% Status is %boinctempcontrolclientstatus%)
if NOT exist %boinctempcontrolclientstate% (echo Boinc Client State file %boinctempcontrolclientstate%)

:foundclientstate

if exist .\%currentboinctempcontrolprogram%-%boinctempcontrollookforthisdash%.txt del .\%currentboinctempcontrolprogram%-%boinctempcontrollookforthisdash%.txt
if exist ".\%currentboinctempcontrolprogram%-client_state.xml" del ".\%currentboinctempcontrolprogram%-client_state.xml"
copy "%boinctempcontrolclientstate%" ".\%currentboinctempcontrolprogram%-client_state.xml" >NUL

if NOT exist %boinctempcontrolclientstate% echo.
if NOT exist %boinctempcontrolclientstate% goto :skipnoclientstatefile

find /i "%boinctempcontrollookforthis25%"  ".\%currentboinctempcontrolprogram%-client_state.xml" > .\%currentboinctempcontrolprogram%-%boinctempcontrollookforthisdash%.txt

FOR /f "tokens=1,2,3 delims=</>" %%G IN (.\%currentboinctempcontrolprogram%-%boinctempcontrollookforthisdash%.txt) DO (
call ::processclientstatefound %%G %%H %%I
)

rem echo find file value %boinctempcontrolfindfilevalue%
rem echo boinctempcontrolrunonlyonce client state area pct=%boinctempcontrolrunonlyonce%=excl=!boinctempcontrolrunonlyonce!=end
:skipclientstateread

if exist .\%currentboinctempcontrolprogram%-%boinctempcontrollookforthisdash%-run-all-the-time.txt del .\%currentboinctempcontrolprogram%-%boinctempcontrollookforthisdash%-run-all-the-time.txt
if exist .\%currentboinctempcontrolprogram%-%boinctempcontrollookforthisdash%-run-based-on-preferences.txt del .\%currentboinctempcontrolprogram%-%boinctempcontrollookforthisdash%-run-based-on-preferences.txt
if exist .\%currentboinctempcontrolprogram%-%boinctempcontrollookforthisdash%-suspended.txt del .\%currentboinctempcontrolprogram%-%boinctempcontrollookforthisdash%-suspended.txt
if exist ".\%currentboinctempcontrolprogram%-client_state.xml" del ".\%currentboinctempcontrolprogram%-client_state.xml"
                                                                                                                        
if "%boinctempcontrolfindfilevalue%"=="1" set boinctempcontrolfindfilevalueback=always
if "%boinctempcontrolfindfilevalue%"=="1" (set boinctempcontrolclientstatus=%boinctempcontrolfindfilevalue% - %boinctempcontrolfindfilevalueback% - Run all the time)
if x%boinctempcontrolrunonlyonce% EQU xyes (
if "%boinctempcontrolfindfilevalue%"=="1" (echo Run All The Time - Running: %currentboinctempcontrolprogramcmd% Located in: %currentboinctempcontroldirectory% %date% %time% > .\%currentboinctempcontrolprogram%-%boinctempcontrollookforthisdash%-run-all-the-time.txt)
rem if x%boinctempcontrolrunonlyonce% EQU xyes (
)

if "%boinctempcontrolfindfilevalue%"=="2" set boinctempcontrolfindfilevalueback=auto
if "%boinctempcontrolfindfilevalue%"=="2" (set boinctempcontrolclientstatus=%boinctempcontrolfindfilevalue% - %boinctempcontrolfindfilevalueback% - Run based on preferences)
if x%boinctempcontrolrunonlyonce% EQU xyes (
if "%boinctempcontrolfindfilevalue%"=="2" (echo Run Based On Perferences - Running: %currentboinctempcontrolprogramcmd% Located in: %currentboinctempcontroldirectory% %date% %time% > .\%currentboinctempcontrolprogram%-%boinctempcontrollookforthisdash%-run-based-on-preferences.txt)
rem if x%boinctempcontrolrunonlyonce% EQU xyes (
)

if "%boinctempcontrolfindfilevalue%"=="3" set boinctempcontrolfindfilevalueback=never
if "%boinctempcontrolfindfilevalue%"=="3" (set boinctempcontrolclientstatus=%boinctempcontrolfindfilevalue% - %boinctempcontrolfindfilevalueback% - Suspended)
if x%boinctempcontrolrunonlyonce% EQU xyes (
if "%boinctempcontrolfindfilevalue%"=="3" (echo Suspended - Running: %currentboinctempcontrolprogramcmd% Located in: %currentboinctempcontroldirectory% %date% %time% > .\%currentboinctempcontrolprogram%-%boinctempcontrollookforthisdash%-suspended.txt)
rem if x%boinctempcontrolrunonlyonce% EQU xyes (
)

rem echo Boinc Client %boinctempcontrollookforthis% Status is %boinctempcontrolclientstatus%
(set boinctempcontroloutputpart1=Boinc Client state %boinctempcontrollookforthis% status)
(set boinctempcontroloutputpart2=value: %boinctempcontrolclientstatus%)
call :eocuhtotheline

:skipnoclientstatefile

if exist .\%currentboinctempcontrolprogram%-%boinctempcontrollookforthisdash%.txt del .\%currentboinctempcontrolprogram%-%boinctempcontrollookforthisdash%.txt
set boinctempcontrolclientprocessed=yes
set boinctempcontrolfindfilevaluebackprev=%boinctempcontrolfindfilevalueback%
set boinctempcontrolfindfilevalueprev=%boinctempcontrolfindfilevalue%
set %1=%boinctempcontrolfindfilevalueback%
exit /b

:processclientstatefound
rem  echo :processfindfile area %1 %2 %3 %4 %5 %6 %7
if /I %1==rem goto :eof

:: length of parse arg
set boinctempcontrolprocessfindfilelookingfor=%1
set boinctempcontrolfindfilevalue=%2
exit /b

:LoCase
if x%subroutinemsg% EQU xyes echo entering :LoCase
:: Subroutine to convert a variable VALUE to all lower case.
:: The argument for this subroutine is the variable NAME.
FOR %%i IN ("A=a" "B=b" "C=c" "D=d" "E=e" "F=f" "G=g" "H=h" "I=i" "J=j" "K=k" "L=l" "M=m" "N=n" "O=o" "P=p" "Q=q" "R=r" "S=s" "T=t" "U=u" "V=v" "W=w" "X=x" "Y=y" "Z=z") DO CALL SET "%1=%%%1:%%~i%%"
exit /b

:UpCase
if x%subroutinemsg% EQU xyes echo entering :UpCase
:: Subroutine to convert a variable VALUE to all UPPER CASE.
:: The argument for this subroutine is the variable NAME.
FOR %%i IN ("a=A" "b=B" "c=C" "d=D" "e=E" "f=F" "g=G" "h=H" "i=I" "j=J" "k=K" "l=L" "m=M" "n=N" "o=O" "p=P" "q=Q" "r=R" "s=S" "t=T" "u=U" "v=V" "w=W" "x=X" "y=Y" "z=Z") DO CALL SET "%1=%%%1:%%~i%%"
exit /b